Index: branches/RWT/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp
===================================================================
--- branches/RWT/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp	(revision 477)
+++ branches/RWT/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp	(revision 495)
@@ -4319,86 +4522,65 @@
         r_xram_rsp_victim_dirty     = victim.dirty or (!victim.cache_coherent && (victim.count == 1)); //a NCC line is by default considered as dirty in the L1: we must take a reservation on a TRT entry
 
-
-        if(!r_xram_rsp_trt_buf.rerror)
-        {
-          if (!victim.cache_coherent and r_xram_rsp_to_ixr_cmd_inval_ncc_pending.read()) //there can not be two L2 invalidation on NCC line at the same time
-          {
-            r_xram_rsp_fsm = XRAM_RSP_INVAL_WAIT;
-          }
-          else
-          {
-            r_xram_rsp_fsm = XRAM_RSP_INVAL_LOCK;
-          }
-        }
-        else
-        {
-          r_xram_rsp_fsm = XRAM_RSP_ERROR_ERASE;
-        }
-
-#if DEBUG_MEMC_XRAM_RSP
+        if( not r_xram_rsp_trt_buf.rerror ) r_xram_rsp_fsm = XRAM_RSP_IVT_LOCK;
+        else                                r_xram_rsp_fsm = XRAM_RSP_ERROR_ERASE;
+
+ #if DEBUG_MEMC_XRAM_RSP
 if(m_debug)
 std::cout << "  <MEMC " << name() << " XRAM_RSP_TRT_COPY>"
-          << " Select a slot: "
+          << " Select a victim slot: "
           << " way = " << std::dec << way
           << " / set = " << set
           << " / inval_required = " << inval << std::endl;
 #endif
-      }
-      else
-      {
-        std::cout << "VCI_MEM_CACHE ERROR " << name() << " XRAM_RSP_TRT_COPY"
-                  << " bad TRT or DIR allocation" << std::endl;
-        exit(0);
-      }
-      break;
-    }
-    /////////////////////////
-    case XRAM_RSP_INVAL_LOCK: // Take the IVT lock to check a possible pending inval
-    {
-      if(r_alloc_ivt_fsm == ALLOC_IVT_XRAM_RSP)
-      {
-        size_t index = 0;
-        size_t index_victim = 0;
-        if(m_ivt.search_inval(r_xram_rsp_trt_buf.nline, index) or
-           m_ivt.search_inval(r_xram_rsp_victim_nline.read(), index_victim))
-        {
-          r_xram_rsp_fsm = XRAM_RSP_INVAL_WAIT;
+        break;
+    }
+    ///////////////////////
+    case XRAM_RSP_IVT_LOCK:   // Keep DIR and TRT locks and take the IVT lock 
+                              // to check a possible pending inval
+    {
+        assert( (r_alloc_dir_fsm.read() == ALLOC_DIR_XRAM_RSP) and
+        "MEMC ERROR in XRAM_RSP_IVT_LOCK state: Bad DIR allocation");
+
+        assert( (r_alloc_trt_fsm.read() == ALLOC_TRT_XRAM_RSP) and
+        "MEMC ERROR in XRAM_RSP_IVT_LOCK state: Bad TRT allocation");
+
+        if(r_alloc_ivt_fsm == ALLOC_IVT_XRAM_RSP)
+        {
+            size_t index = 0;
+            if(m_ivt.search_inval(r_xram_rsp_trt_buf.nline, index))  // pending inval
+            {
+                r_xram_rsp_fsm = XRAM_RSP_INVAL_WAIT;
 
 #if DEBUG_MEMC_XRAM_RSP
 if(m_debug)
-std::cout << "  <MEMC " << name() << " XRAM_RSP_INVAL_LOCK>"
+std::cout << "  <MEMC " << name() << " XRAM_RSP_IVT_LOCK>"
           << " Get acces to IVT, but line invalidation registered"
-          << " / nline = " << std::hex << r_xram_rsp_trt_buf.nline
+          << " / address = " << std::hex << r_xram_rsp_trt_buf.nline*m_words*4
           << " / index = " << std::dec << index << std::endl;
 #endif
 
-        }
-        else if(m_ivt.is_full() and r_xram_rsp_victim_inval.read()) // IVT full
-        {
-          r_xram_rsp_fsm = XRAM_RSP_INVAL_WAIT;
-          m_upt.print();
+            }
+            else if(m_ivt.is_full() and r_xram_rsp_victim_inval.read()) // IVT full
+            {
+                r_xram_rsp_fsm = XRAM_RSP_INVAL_WAIT;
 
 #if DEBUG_MEMC_XRAM_RSP
 if(m_debug)
-std::cout << "  <MEMC " << name() << " XRAM_RSP_INVAL_LOCK>"
+std::cout << "  <MEMC " << name() << " XRAM_RSP_IVT_LOCK>"
           << " Get acces to IVT, but inval required and IVT full" << std::endl;
 #endif
-        }
-        else
-        {
-          r_xram_rsp_fsm = XRAM_RSP_DIR_UPDT;
+            }
+            else
+            {
+                r_xram_rsp_fsm = XRAM_RSP_DIR_UPDT;
 
 #if DEBUG_MEMC_XRAM_RSP
 if(m_debug)
-std::cout << "  <MEMC " << name() << " XRAM_RSP_INVAL_LOCK>"
-          << " Get acces to IVT" << std::endl;
-#endif
-        }
-        m_cpt_xram_rsp_fsm_n_upt_lock++;
-      }
-
-      m_cpt_xram_rsp_fsm_upt_lock++;
-
-      break;
+std::cout << "  <MEMC " << name() << " XRAM_RSP_IVT_LOCK>"
+          << " Get acces to IVT / no pending inval request" << std::endl;
+#endif
+            }
+        }
+        break;
     }
     /////////////////////////
@@ -4415,34 +4597,39 @@
     }
     ///////////////////////
-    case XRAM_RSP_DIR_UPDT:   // updates the cache (both data & directory)
-                              // and possibly set an inval request in IVT
-    {
-      // check if this is an instruction read, this means pktid is either
-      // TYPE_READ_INS_UNC   0bX010 with TSAR encoding
-      // TYPE_READ_INS_MISS  0bX011 with TSAR encoding
-      bool inst_read = (r_xram_rsp_trt_buf.pktid & 0x2) and r_xram_rsp_trt_buf.proc_read;
-
-      // check if this is a cached read, this means pktid is either
-      // TYPE_READ_DATA_MISS 0bX001 with TSAR encoding
-      // TYPE_READ_INS_MISS  0bX011 with TSAR encoding
-      bool cached_read = (r_xram_rsp_trt_buf.pktid & 0x1) and r_xram_rsp_trt_buf.proc_read;
-
-      bool dirty = false;
-
-      // update cache data
-      size_t set   = r_xram_rsp_victim_set.read();
-      size_t way   = r_xram_rsp_victim_way.read();
-      for(size_t word=0; word<m_words ; word++)
-      {
-        m_cache_data.write(way, set, word, r_xram_rsp_trt_buf.wdata[word]);
-
-        dirty = dirty or (r_xram_rsp_trt_buf.wdata_be[word] != 0);
-
-        if(m_monitor_ok)
-        {
-          addr_t address = r_xram_rsp_trt_buf.nline<<6 | word<<2;
-          check_monitor( address, r_xram_rsp_trt_buf.wdata[word], false);
-        }
-      }
+    case XRAM_RSP_DIR_UPDT:   // updates the cache (both data & directory),
+                              // erases the TRT entry if victim not dirty,
+                              // and set inval request in IVT if required
+    {
+        assert( (r_alloc_dir_fsm.read() == ALLOC_DIR_XRAM_RSP) and
+        "MEMC ERROR in XRAM_RSP_DIR_UPDT state: Bad DIR allocation");
+
+        assert( (r_alloc_trt_fsm.read() == ALLOC_TRT_XRAM_RSP) and
+        "MEMC ERROR in XRAM_RSP_DIR_UPDT state: Bad TRT allocation");
+ 
+        assert( (r_alloc_ivt_fsm.read() == ALLOC_IVT_XRAM_RSP) and
+        "MEMC ERROR in XRAM_RSP_DIR_UPDT state: Bad IVT allocation");
+
+        // check if this is an instruction read, this means pktid is either
+        // TYPE_READ_INS_UNC   0bX010 with TSAR encoding
+        // TYPE_READ_INS_MISS  0bX011 with TSAR encoding
+
+        // check if this is a cached read, this means pktid is either
+        // TYPE_READ_DATA_MISS 0bX001 with TSAR encoding
+        // TYPE_READ_INS_MISS  0bX011 with TSAR encoding
+        bool cached_read = (r_xram_rsp_trt_buf.pktid & 0x1) and r_xram_rsp_trt_buf.proc_read;
+ 
+        bool inst_read = (r_xram_rsp_trt_buf.pktid & 0x2) and r_xram_rsp_trt_buf.proc_read;
+ 
+        bool dirty = false;
+
+        // update cache data
+        size_t set   = r_xram_rsp_victim_set.read();
+        size_t way   = r_xram_rsp_victim_way.read();
+        for(size_t word=0; word<m_words ; word++)
+        {
+          m_cache_data.write(way, set, word, r_xram_rsp_trt_buf.wdata[word]);
+          dirty = dirty or (r_xram_rsp_trt_buf.wdata_be[word] != 0);
+
+        }
 
       // update cache directory
@@ -4458,7 +4645,4 @@
       {
         entry.owner.srcid   = r_xram_rsp_trt_buf.srcid;
-#if L1_MULTI_CACHE
-        entry.owner.cache_id= r_xram_rsp_trt_buf.pktid;
-#endif
         entry.owner.inst    = inst_read;
         entry.count         = 1;
@@ -4466,8 +4650,5 @@
       else
       {
-        entry.owner.srcid    = r_xram_rsp_trt_buf.srcid;
-#if L1_MULTI_CACHE
-        entry.owner.cache_id = 0;
-#endif
+        entry.owner.srcid    = 0;
         entry.owner.inst     = 0;
         entry.count          = 0;
@@ -4495,15 +4676,12 @@
 
         r_xram_rsp_ivt_index = index;
-        if(!wok)
-        {
-          std::cout << "VCI_MEM_CACHE ERROR " << name() << " XRAM_RSP_DIR_UPDT"
-                    << " invalidate_tab entry free but write unsuccessful" << std::endl;
-          exit(0);
-        }
+        assert( wok and
+        "MEMC ERROR in XRAM_RSP_DIR_UPDT state: IVT should not be full"); 
+ 
       }
       if (!r_xram_rsp_victim_coherent.read())
       {
         //m_llsc_table.sw(r_xram_rsp_victim_nline.read()*m_words*4);
-        m_llsc_table.sw(r_xram_rsp_victim_nline.read());
+        m_llsc_table.sw(r_xram_rsp_victim_nline.read(), 0, m_words - 1);
       }
 #if DEBUG_MEMC_XRAM_RSP
@@ -4539,25 +4717,33 @@
     case XRAM_RSP_TRT_DIRTY:  // set the TRT entry (write to XRAM) if the victim is dirty or not coherent (RWT)
     {
-      if(r_alloc_trt_fsm.read() == ALLOC_TRT_XRAM_RSP)
-      {
-
-        m_trt.set(r_xram_rsp_trt_index.read(),
-                              false,       // write to XRAM
-                              r_xram_rsp_victim_nline.read(),  // line index
-                              0,
-                              0,
-                              0,
-                              false,
-                              0,
-                              0,
-                              std::vector<be_t> (m_words,0),
-                              std::vector<data_t> (m_words,0));
-
-#if DEBUG_MEMC_XRAM_RSP
-if(m_debug)
+        if(r_alloc_trt_fsm.read() == ALLOC_TRT_XRAM_RSP)
+        {
+            std::vector<data_t> data_vector;
+            data_vector.clear();
+            for(size_t i=0; i<m_words; i++)
+            {
+                data_vector.push_back(r_xram_rsp_victim_data[i].read());
+            }
+            m_trt.set( r_xram_rsp_trt_index.read(),
+                       false,                             // PUT
+                       r_xram_rsp_victim_nline.read(),    // line index
+                       0,                                 // unused
+                       0,                                 // unused
+                       0,                                 // unused
+                       false,                             // not proc_read
+                       0,                                 // unused
+                       0,                                 // unused
+                       std::vector<be_t>(m_words,0xF),                         
+                       data_vector);
+ #if DEBUG_MEMC_XRAM_RSP
+if(m_debug)
+            m_trt.print(0);
 std::cout << "  <MEMC " << name() << " XRAM_RSP_TRT_DIRTY>"
           << " Set TRT entry for the put transaction"
           << " / dirty victim line = " << r_xram_rsp_victim_nline.read() << std::endl;
 #endif
+        
+        if( not r_xram_rsp_victim_coherent )
+            std::cout << "a victim coherent not sent trt index =" << r_xram_rsp_trt_index.read() << std::endl;
         if(r_xram_rsp_trt_buf.proc_read)         r_xram_rsp_fsm = XRAM_RSP_DIR_RSP;
         else if(r_xram_rsp_victim_inval.read())  r_xram_rsp_fsm = XRAM_RSP_INVAL;
@@ -4573,5 +4759,5 @@
     case XRAM_RSP_DIR_RSP:     // Request a response to TGT_RSP FSM
     {
-      if(!r_xram_rsp_to_tgt_rsp_req.read())
+      if( not r_xram_rsp_to_tgt_rsp_req.read())
       {
         r_xram_rsp_to_tgt_rsp_srcid = r_xram_rsp_trt_buf.srcid;
@@ -4627,19 +4813,17 @@
         xram_rsp_to_cc_send_fifo_srcid     = r_xram_rsp_victim_copy.read();
         xram_rsp_to_cc_send_fifo_inst      = r_xram_rsp_victim_copy_inst.read();
-#if L1_MULTI_CACHE
-        xram_rsp_to_cc_send_fifo_cache_id  = r_xram_rsp_victim_copy_cache.read();
-#endif
         xram_rsp_to_cc_send_fifo_put       = multi_req;
-        r_xram_rsp_next_ptr                 = r_xram_rsp_victim_ptr.read();
-
-        if(r_xram_rsp_victim_dirty)  r_xram_rsp_fsm = XRAM_RSP_WRITE_DIRTY;
+        r_xram_rsp_next_ptr                = r_xram_rsp_victim_ptr.read();
+
+        if(r_xram_rsp_victim_dirty and r_xram_rsp_victim_coherent)  r_xram_rsp_fsm = XRAM_RSP_WRITE_DIRTY;
         else if(not_last_multi_req)  r_xram_rsp_fsm = XRAM_RSP_HEAP_REQ;
         else                         r_xram_rsp_fsm = XRAM_RSP_IDLE;
 
+// std::cout << "cleanup sent for trt index =" << r_xram_rsp_trt_index.read() << std::endl;
 #if DEBUG_MEMC_XRAM_RSP
 if(m_debug)
 std::cout << "  <MEMC " << name() << " XRAM_RSP_INVAL>"
           << " Send an inval request to CC_SEND FSM"
-          << " / victim line = " << r_xram_rsp_victim_nline.read() << std::endl;
+          << " / address = " << r_xram_rsp_victim_nline.read()*m_words*4 << std::endl;
 #endif
       }
@@ -4649,29 +4833,17 @@
     case XRAM_RSP_WRITE_DIRTY:  // send a write request to IXR_CMD FSM
     {
-      if(!r_xram_rsp_to_ixr_cmd_req.read() and !r_xram_rsp_to_ixr_cmd_inval_ncc_pending.read())
-      {
-        r_xram_rsp_to_ixr_cmd_req = true;
-        r_xram_rsp_to_ixr_cmd_nline = r_xram_rsp_victim_nline.read();
-        r_xram_rsp_to_ixr_cmd_trdid = r_xram_rsp_trt_index.read();
-        for(size_t i=0; i<m_words ; i++)
-        {
-            r_xram_rsp_to_ixr_cmd_data[i] = r_xram_rsp_victim_data[i];
-              std::cout << "data L2 = " << std::hex << r_xram_rsp_victim_data[i] << std::dec << std::endl;
-        }
-        m_cpt_write_dirty++;
+        if ( not r_xram_rsp_to_ixr_cmd_req.read() )
+        {
+            r_xram_rsp_to_ixr_cmd_req = true;
+            r_xram_rsp_to_ixr_cmd_index = r_xram_rsp_trt_index.read();
+ 
+            m_cpt_write_dirty++;
         
-        if ((!r_xram_rsp_victim_coherent.read()) and (r_xram_rsp_victim_count.read() == 1)) //if NCC, we save the data in case of not dirty L1
-        {
-          r_xram_rsp_to_ixr_cmd_req = false;
-          r_xram_rsp_to_ixr_cmd_inval_ncc_pending = true;
-          r_xram_rsp_fsm = XRAM_RSP_IDLE;
-          break;
-        }
-
-        bool multi_req = !r_xram_rsp_victim_is_cnt.read() and r_xram_rsp_victim_inval.read();
-        bool not_last_multi_req = multi_req and (r_xram_rsp_victim_count.read() != 1);
-
-        if(not_last_multi_req)   r_xram_rsp_fsm = XRAM_RSP_HEAP_REQ;
-        else                     r_xram_rsp_fsm = XRAM_RSP_IDLE;
+            bool multi_req = not r_xram_rsp_victim_is_cnt.read() and 
+              r_xram_rsp_victim_inval.read();
+            bool not_last_multi_req = multi_req and (r_xram_rsp_victim_count.read() != 1);
+
+            if(not_last_multi_req)   r_xram_rsp_fsm = XRAM_RSP_HEAP_REQ;
+            else                     r_xram_rsp_fsm = XRAM_RSP_IDLE;
 
 #if DEBUG_MEMC_XRAM_RSP
@@ -4681,6 +4853,6 @@
           << " / victim line = " << r_xram_rsp_victim_nline.read() << std::endl;
 #endif
-      }
-      break;
+         }
+        break;
     }
     /////////////////////////
@@ -4711,7 +4883,4 @@
 
         xram_rsp_to_cc_send_fifo_srcid    = entry.owner.srcid;
-#if L1_MULTI_CACHE
-        xram_rsp_to_cc_send_fifo_cache_id = entry.owner.cache_id;
-#endif
         xram_rsp_to_cc_send_fifo_inst  = entry.owner.inst;
         xram_rsp_to_cc_send_fifo_put   = true;
@@ -4757,7 +4926,4 @@
       HeapEntry last_entry;
       last_entry.owner.srcid    = 0;
-#if L1_MULTI_CACHE
-      last_entry.owner.cache_id = 0;
-#endif
       last_entry.owner.inst     = false;
       if(m_heap.is_full())
@@ -4783,5 +4949,5 @@
       break;
     }
-    // ///////////////////////
+    /////////////////////////
     case XRAM_RSP_ERROR_ERASE:  // erase TRT entry in case of error
     {
@@ -4873,13 +5039,6 @@
       r_cleanup_contains_data = false;
 
-      if(srcid >= m_initiators)
-      {
-        std::cout
-            << "VCI_MEM_CACHE ERROR " << name()
-            << " CLEANUP_IDLE state"  << std::endl
-            << "illegal srcid for cleanup request" << std::endl;
-
-        exit(0);
-      }
+      assert( (srcid < m_initiators) and
+      "MEMC ERROR in CLEANUP_IDLE state : illegal SRCID value");
 
       m_cpt_cleanup++;
@@ -5026,7 +5185,4 @@
       r_cleanup_copy         = entry.owner.srcid;
       r_cleanup_copy_inst    = entry.owner.inst;
-#if L1_MULTI_CACHE
-      r_cleanup_copy_cache   = entry.owner.cache_id;
-#endif
 
       //RWT
@@ -5034,6 +5190,4 @@
       m_cache_data.read_line(way, set, r_cleanup_old_data); 
       r_cleanup_coherent = entry.cache_coherent;
-
-
 
       if(entry.valid)      // hit : the copy must be cleared
@@ -5101,8 +5255,4 @@
       bool   match_srcid = (r_cleanup_copy.read() == r_cleanup_srcid.read());
 
-#if L1_MULTI_CACHE
-      match_srcid       &= (r_cleanup_copy_cache.read() == r_cleanup_pktid.read());
-#endif
-
       bool   match_inst  = (r_cleanup_copy_inst.read() == r_cleanup_inst.read());
       bool   match       = match_srcid and match_inst;
@@ -5149,7 +5299,4 @@
           entry.owner.srcid    = r_read_to_cleanup_srcid.read();
           entry.owner.inst     = 0;
-#if L1_MULTI_CACHE
-          entry.owner.cache_id = r_cleanup_copy_cache.read();
-#endif
         }
         else
@@ -5158,7 +5305,4 @@
           entry.owner.srcid    = r_cleanup_copy.read();
           entry.owner.inst     = r_cleanup_copy_inst.read();
-#if L1_MULTI_CACHE
-          entry.owner.cache_id = r_cleanup_copy_cache.read();
-#endif
         }
         if (r_read_to_cleanup_is_ll.read())
@@ -5172,9 +5316,5 @@
         entry.owner.srcid    = 0;
         entry.owner.inst     = 0;
-#if L1_MULTI_CACHE
-        entry.owner.cache_id = 0;
-#endif
-      }
-
+      }
 
       if (r_cleanup_contains_data.read())
@@ -5184,11 +5324,9 @@
           m_cache_data.write(way, set, word, r_cleanup_data[word].read(), 0xF);
         }
-        m_llsc_table.sw(r_cleanup_nline.read());
+        m_llsc_table.sw(r_cleanup_nline.read(), 0 , m_words - 1);
         //m_llsc_table.sw(r_cleanup_nline.read()*m_words*4);
       }
 
-
       m_cache_directory.write(set, way, entry);
-
 
       /*RWT*/
@@ -5346,13 +5484,6 @@
       // 1. the matching copy is directly in the directory
       // 2. the matching copy is the first copy in the heap
-      if(r_alloc_heap_fsm.read() != ALLOC_HEAP_CLEANUP)
-      {
-        std::cout
-            << "VCI_MEM_CACHE ERROR " << name()
-            << " CLEANUP_HEAP_LOCK state"
-            << " bad HEAP allocation" << std::endl;
-
-        exit(0);
-      }
+      assert( (r_alloc_heap_fsm.read() == ALLOC_HEAP_CLEANUP) and
+      "MEMC ERROR in CLEANUP_HEAP_LOCK state: bad HEAP allocation");
 
       size_t way            = r_cleanup_way.read();
@@ -5376,49 +5507,9 @@
       r_cleanup_prev_inst   = heap_entry.owner.inst;
 
-#if L1_MULTI_CACHE
-      match_dir  = match_dir  and(r_cleanup_copy_cache.read() == r_cleanup_pktid.read());
-      match_heap = match_heap and(heap_entry.owner.cache_id   == r_cleanup_pktid.read());
-      r_cleanup_prev_cache_id = heap_entry.owner.cache_id;
-#endif
-
-      if(not match_dir and not match_heap and last)
-      {
-        std::cout
-            << "VCI_MEM_CACHE ERROR " << name()
-            << " CLEANUP_HEAP_LOCK state"
-            << " hit but copy not found"
-            << std::endl;
-/**/
-        std::cout
-          << "r_cleanup_srcid = " << r_cleanup_srcid.read()
-          << " / r_cleanup_inst = " << r_cleanup_inst.read() << std::endl
-          << "r_cleanup_copy = " << r_cleanup_copy.read()
-          << " / r_cleanup_copy_inst = " << r_cleanup_copy_inst.read() << std::endl
-          << "heap_entry.owner.srcid = " << heap_entry.owner.srcid
-          << " / heap_entry.owner.inst = " << heap_entry.owner.inst << std::endl
-/**/
-          << "nline = " << r_cleanup_nline << std::endl;
-        exit(0);
-      }
-
-      if(match_dir and match_heap)
-      {
-        std::cout
-            << "VCI_MEM_CACHE ERROR " << name()
-            << " CLEANUP_HEAP_LOCK state"
-            << " two copies matching the cleanup owner id"
-            << std::endl;
-/**/
-        std::cout
-          << "r_cleanup_srcid = " << r_cleanup_srcid.read()
-          << " / r_cleanup_inst = " << r_cleanup_inst.read() << std::endl
-          << "r_cleanup_copy = " << r_cleanup_copy.read()
-          << " / r_cleanup_copy_inst = " << r_cleanup_copy_inst.read() << std::endl
-          << "heap_entry.owner.srcid = " << heap_entry.owner.srcid
-          << " / heap_entry.owner.inst = " << heap_entry.owner.inst << std::endl
-/**/
-          << "nline = " << r_cleanup_nline << std::endl;
-        exit(0);
-      }
+      assert( (not last or match_dir or match_heap) and
+      "MEMC ERROR in CLEANUP_HEAP_LOCK state: hit but no copy found");
+
+      assert( (not match_dir or not match_heap) and
+      "MEMC ERROR in CLEANUP_HEAP_LOCK state: two matching copies found");
 
       DirectoryEntry dir_entry;
@@ -5439,9 +5530,4 @@
         dir_entry.owner.srcid    = heap_entry.owner.srcid;
         dir_entry.owner.inst     = heap_entry.owner.inst;
-
-#if L1_MULTI_CACHE
-        dir_entry.owner.cache_id = heap_entry.owner.cache_id;
-#endif
-
         r_cleanup_next_ptr       = r_cleanup_ptr.read();
         r_cleanup_fsm            = CLEANUP_HEAP_FREE;
@@ -5456,9 +5542,4 @@
         dir_entry.owner.srcid    = r_cleanup_copy.read();
         dir_entry.owner.inst     = r_cleanup_copy_inst.read();
-
-#if L1_MULTI_CACHE
-        dir_entry.owner.cache_id = r_cleanup_copy_cache.read();
-#endif
-
         r_cleanup_next_ptr       = r_cleanup_ptr.read();
         r_cleanup_fsm            = CLEANUP_HEAP_FREE;
@@ -5472,9 +5553,4 @@
         dir_entry.owner.srcid    = r_cleanup_copy.read();
         dir_entry.owner.inst     = r_cleanup_copy_inst.read();
-
-#if L1_MULTI_CACHE
-        dir_entry.owner.cache_id = r_cleanup_copy_cache.read();
-#endif
-
         r_cleanup_next_ptr       = heap_entry.next;
         r_cleanup_fsm            = CLEANUP_HEAP_SEARCH;
@@ -5482,5 +5558,4 @@
 
       m_cache_directory.write(set,way,dir_entry);
-
 
 #if DEBUG_MEMC_CLEANUP
@@ -5508,13 +5583,6 @@
       // This state is handling the case where the copy
       // is in the heap, but is not the first in the linked list
-      if(r_alloc_heap_fsm.read() != ALLOC_HEAP_CLEANUP)
-      {
-        std::cout
-            << "VCI_MEM_CACHE ERROR " << name()
-            << " CLEANUP_HEAP_SEARCH state"
-            << " bad HEAP allocation" << std::endl;
-
-        exit(0);
-      }
+      assert( (r_alloc_heap_fsm.read() == ALLOC_HEAP_CLEANUP) and
+     "MEMC ERROR in CLEANUP_HEAP_LOCK state: bad HEAP allocation");
 
       HeapEntry heap_entry  = m_heap.read(r_cleanup_next_ptr.read());
@@ -5525,20 +5593,8 @@
       bool match_heap       = match_heap_srcid and match_heap_inst;
 
-#if L1_MULTI_CACHE
-      match_heap = match_heap and(heap_entry.owner.cache_id == r_cleanup_pktid.read());
-#endif
-
-      if(not match_heap and last)
-      {
-        std::cout
-            << "VCI_MEM_CACHE_ERROR " << name()
-            << " CLEANUP_HEAP_SEARCH state"
-            << " cleanup on valid line but copy not found"
-            << std::endl;
-
-        exit(0);
-      }
-
-      // the matching copy must be removed
+      assert( (not last or match_heap) and
+      "MEMC ERROR in CLEANUP_HEAP_SEARCH state: no copy found");
+
+       // the matching copy must be removed
       if(match_heap)
       {
@@ -5554,10 +5610,5 @@
         r_cleanup_prev_inst     = heap_entry.owner.inst;
         r_cleanup_next_ptr      = heap_entry.next;
-
         r_cleanup_fsm           = CLEANUP_HEAP_SEARCH;
-
-#if L1_MULTI_CACHE
-        r_cleanup_prev_cache_id = heap_entry.owner.cache_id;
-#endif
       }
 
@@ -5595,22 +5646,10 @@
     case CLEANUP_HEAP_CLEAN:    // remove a copy in the linked list
     {
-      if(r_alloc_heap_fsm.read() != ALLOC_HEAP_CLEANUP)
-      {
-        std::cout
-            << "VCI_MEM_CACHE ERROR " << name()
-            << " CLEANUP_HEAP_CLEAN state"
-            << "Bad HEAP allocation"  << std::endl;
-
-        exit(0);
-      }
+     assert( (r_alloc_heap_fsm.read() == ALLOC_HEAP_CLEANUP) and
+     "MEMC ERROR in CLEANUP_HEAP_LOCK state: bad HEAP allocation");
 
       HeapEntry heap_entry;
       heap_entry.owner.srcid    = r_cleanup_prev_srcid.read();
       heap_entry.owner.inst     = r_cleanup_prev_inst.read();
-
-#if L1_MULTI_CACHE
-      heap_entry.owner.cache_id = r_cleanup_prev_cache_id.read();
-#endif
-
       bool last = (r_cleanup_next_ptr.read() == r_cleanup_ptr.read());
 
@@ -5641,21 +5680,9 @@
                               // and becomes the head of the list of free entries
     {
-      if(r_alloc_heap_fsm.read() != ALLOC_HEAP_CLEANUP)
-      {
-        std::cout
-            << "VCI_MEM_CACHE ERROR " << name()
-            << " CLEANUP_HEAP_CLEAN state" << std::endl
-            << "Bad HEAP allocation" << std::endl;
-
-        exit(0);
-      }
-
+     assert( (r_alloc_heap_fsm.read() == ALLOC_HEAP_CLEANUP) and
+     "MEMC ERROR in CLEANUP_HEAP_LOCK state: bad HEAP allocation");
       HeapEntry heap_entry;
       heap_entry.owner.srcid    = 0;
       heap_entry.owner.inst     = false;
-
-#if L1_MULTI_CACHE
-      heap_entry.owner.cache_id = 0;
-#endif
 
       if(m_heap.is_full())
@@ -5706,17 +5733,15 @@
 #endif
         m_cpt_cleanup_fsm_n_upt_lock++;
-        break;
-      }
-
-      // pending inval
-      r_cleanup_write_srcid = m_ivt.srcid(index);
-      r_cleanup_write_trdid = m_ivt.trdid(index);
-      r_cleanup_write_pktid = m_ivt.pktid(index);
-      r_cleanup_need_rsp    = m_ivt.need_rsp(index);
-      r_cleanup_need_ack    = m_ivt.need_ack(index);
-      r_cleanup_index       = index;
-
-      r_cleanup_fsm         = CLEANUP_IVT_DECREMENT;
-
+      }
+      else
+      {
+        // pending inval
+        r_cleanup_write_srcid = m_ivt.srcid(index);
+        r_cleanup_write_trdid = m_ivt.trdid(index);
+        r_cleanup_write_pktid = m_ivt.pktid(index);
+        r_cleanup_need_rsp    = m_ivt.need_rsp(index);
+        r_cleanup_need_ack    = m_ivt.need_ack(index);
+        r_cleanup_index       = index;
+        r_cleanup_fsm         = CLEANUP_IVT_DECREMENT;
 #if DEBUG_MEMC_CLEANUP
 if(m_debug)
@@ -5727,4 +5752,5 @@
           << " / ivt_entry = " << index << std::endl;
 #endif
+      }
       break;
     }
@@ -5732,18 +5758,9 @@
     case CLEANUP_IVT_DECREMENT: // decrement response counter in IVT matching entry
     {
-      if(r_alloc_ivt_fsm.read() != ALLOC_IVT_CLEANUP)
-      {
-        std::cout
-            << "VCI_MEM_CACHE ERROR "         << name()
-            << " CLEANUP_IVT_DECREMENT state" << std::endl
-            << "Bad IVT allocation"
-            << std::endl;
-
-        exit(0);
-      }
+      assert( (r_alloc_ivt_fsm.read() == ALLOC_IVT_CLEANUP) and
+      "MEMC ERROR in CLEANUP_IVT_DECREMENT state: Bad IVT allocation");
 
       size_t count = 0;
       m_ivt.decrement(r_cleanup_index.read(), count);
-
 
       if(count == 0)   // multi inval transaction completed
@@ -5775,19 +5792,18 @@
     case CLEANUP_IVT_CLEAR:    // Clear IVT entry 
     {
-      if(r_alloc_ivt_fsm.read() != ALLOC_IVT_CLEANUP)
-      {
-        std::cout
-            << "VCI_MEM_CACHE ERROR "     << name()
-            << " CLEANUP_IVT_CLEAR state" << std::endl
-            << "Bad IVT allocation"
-            << std::endl;
-
-        exit(0);
-      }
+      assert( (r_alloc_ivt_fsm.read() == ALLOC_IVT_CLEANUP) and
+      "MEMC ERROR in CLEANUP_IVT_CLEAR state : bad IVT allocation");
 
       m_ivt.clear(r_cleanup_index.read());
 
+      if ( r_cleanup_need_ack.read() )
+      {
+          assert( (r_config_rsp_lines.read() > 0) and
+          "MEMC ERROR in CLEANUP_IVT_CLEAR state");
+
+          r_config_rsp_lines = r_config_rsp_lines.read() - 1;
+      }
+
       if      ( r_cleanup_need_rsp.read() ) r_cleanup_fsm = CLEANUP_WRITE_RSP;
-      else if ( r_cleanup_need_ack.read() ) r_cleanup_fsm = CLEANUP_CONFIG_ACK;
       else if ( r_cleanup_ncc.read()      ) r_cleanup_fsm = CLEANUP_IXR_REQ;
       else                                  r_cleanup_fsm = CLEANUP_SEND_CLACK;
@@ -5799,6 +5815,6 @@
           << " IVT_index = " << r_cleanup_index.read() << std::endl;
 #endif
-      break;
-    }
+          break;
+      }
     ///////////////////////
     case CLEANUP_WRITE_RSP:    // response to a previous write on the direct network
@@ -5812,5 +5828,5 @@
       r_cleanup_to_tgt_rsp_trdid   = r_cleanup_write_trdid.read();
       r_cleanup_to_tgt_rsp_pktid   = r_cleanup_write_pktid.read();
-      r_cleanup_to_tgt_rsp_type    = true;
+      r_cleanup_to_tgt_rsp_type    = true; 
 
       if (r_cleanup_ncc.read())
@@ -5833,29 +5849,11 @@
       break;
     }
-    ////////////////////////
-    case CLEANUP_CONFIG_ACK:   // signals inval completion to CONFIG FSM
-                               // wait if pending request
-    {
-      if ( r_cleanup_to_config_ack.read() ) break;
-
-      r_cleanup_to_config_ack      = true;
-      r_cleanup_fsm                = CLEANUP_SEND_CLACK;
-
-#if DEBUG_MEMC_CLEANUP
-if(m_debug)
-std::cout << "  <MEMC " << name() << " CLEANUP_CONFIG_ACK>"
-          << " Acknowledge broacast inval completion" << std::endl;
-#endif
-      break;
-    }
-
     /////////////////////////
     case CLEANUP_IXR_REQ:
     {
-    
       //Send a request to the ixr to write the data in the XRAM using the prereserved TRT entry
       if (r_alloc_trt_fsm.read() == ALLOC_TRT_CLEANUP)
       {
-        if(!r_cleanup_to_ixr_cmd_req.read())
+        if( not r_cleanup_to_ixr_cmd_req.read())
         {
           size_t index = 0;
@@ -5864,19 +5862,39 @@
           assert (hit and "CLEANUP_IXR_REQ found no matching entry in TRT");
 
-            r_cleanup_to_ixr_cmd_req     = true;
-
-            for(size_t i = 0; i < m_words; i++){
-              r_cleanup_to_ixr_cmd_data[i]   = r_cleanup_data[i];
+          r_cleanup_to_ixr_cmd_req     = true;
+
+          if (r_cleanup_contains_data.read())
+          {  
+            std::vector<data_t> data_vector;
+            data_vector.clear();
+
+            for(size_t i=0; i<m_words; i++)
+            {
+              data_vector.push_back(r_cleanup_data[i]);
             }
 
-            r_cleanup_to_ixr_cmd_srcid   = r_cleanup_srcid.read();
-            r_cleanup_to_ixr_cmd_trdid   = index;
-            r_cleanup_to_ixr_cmd_pktid   = r_cleanup_pktid.read();
-            r_cleanup_to_ixr_cmd_nline   = r_cleanup_nline.read();
-            r_cleanup_to_ixr_cmd_ncc_l1_dirty = r_cleanup_contains_data.read();
-            r_cleanup_fsm = CLEANUP_SEND_CLACK;
+            m_trt.set(index,
+                      false,       // write to XRAM
+                      r_cleanup_nline.read(),  // line index
+                      0,
+                      0,
+                      0,
+                      false,
+                      0,
+                      0,
+                      std::vector<be_t> (m_words,0),
+                      data_vector);
+          }
+//std::cout << "cleanup with a non coherent ligne in trt index = " << index << std::endl;
+          r_cleanup_to_ixr_cmd_srcid        = r_cleanup_srcid.read();
+          r_cleanup_to_ixr_cmd_index        = index;
+          r_cleanup_to_ixr_cmd_pktid        = r_cleanup_pktid.read();
+          r_cleanup_to_ixr_cmd_nline        = r_cleanup_nline.read();
+          //r_cleanup_to_ixr_cmd_l1_dirty_ncc = r_cleanup_contains_data.read();
+          r_cleanup_fsm = CLEANUP_SEND_CLACK;
 #if DEBUG_MEMC_CLEANUP
       if(m_debug)
       {
+        m_trt.print(0);
         std::cout
             << "  <MEMC " << name()
